-- Pylon: a foundation library; version 0.81(beta); 1997-05-08

-- 
-- Copyright (c) 1997 AlterSoft, England, E.U.
-- 
-- Permission is hereby granted, without written agreement and without
-- licence or royalty fees, to use, copy, modify, or distribute this source
-- code or binary programs using it or part of it, subject to the following
-- condition:
-- 
-- The above copyright notice and the following disclaimer must appear in
-- all copies or substantial portions of this source code. (Binary programs
-- derived from the source code can be distributed without restriction or
-- mention of the origin of the source.)
-- 
-- THIS SOFTWARE IS PROVIDED BY ALTERSOFT AND THE AUTHORS ``AS IS'' AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-- ARE DISCLAIMED. IN NO EVENT SHALL ALTERSOFT OR THE AUTHORS BE LIABLE
-- TO ANY PARTY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
-- CONSEQUENTIAL DAMAGES ARISING IN ANY WAY OUT OF THE USE OF THIS SOURCE
-- CODE.
-- 

indexing
	cluster: Pylon, Internal
	description: "Dictionary node"
	interface: internal, client

class P_DICT_NODE[G,K -> HASHABLE]

inherit
	HASHABLE
		redefine
			out,is_equal
		end

feature -- Data
	
	item : G

	set_item(it : G) is
			-- Change item.
		do
			item := it
		ensure
			keep_reference: it = item
		end

	key : K

	set_key(ke : K) is
			-- Change key.
		require
			not_void: not is_void(ke)
		do
			key := ke
		ensure
			keep_reference: key = ke
		end

	is_void(x : ANY) : BOOLEAN is
			-- Is value void? (generic)
		do
			Result := (x = Void)
		end

feature -- Hash
	
	hash_code : INTEGER is 
		do
			check has_key_for_hashcode: key /= Void end
			Result := key.hash_code 
		ensure then
			key_code: Result = key.hash_code
		end

feature -- General

	is_equal(other : like Current) : BOOLEAN is
		do
			Result := key.is_equal(other.key)
		end

	out : STRING is
		do
			!!Result.make(0)
			Result.append_character('(')
			Result.append_string(key.out)
			Result.append_character(':')
			Result.append_string(item.out)
			Result.append_character(')')
		end
	
invariant
	hash: key /= Void implies hash_code = key.hash_code

end
