-- Pylon: a foundation library; version 0.81(beta); 1997-05-08

-- 
-- Copyright (c) 1997 AlterSoft, England, E.U.
-- 
-- Permission is hereby granted, without written agreement and without
-- licence or royalty fees, to use, copy, modify, or distribute this source
-- code or binary programs using it or part of it, subject to the following
-- condition:
-- 
-- The above copyright notice and the following disclaimer must appear in
-- all copies or substantial portions of this source code. (Binary programs
-- derived from the source code can be distributed without restriction or
-- mention of the origin of the source.)
-- 
-- THIS SOFTWARE IS PROVIDED BY ALTERSOFT AND THE AUTHORS ``AS IS'' AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-- ARE DISCLAIMED. IN NO EVENT SHALL ALTERSOFT OR THE AUTHORS BE LIABLE
-- TO ANY PARTY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
-- CONSEQUENTIAL DAMAGES ARISING IN ANY WAY OUT OF THE USE OF THIS SOURCE
-- CODE.
-- 

indexing
	cluster: Pylon
	description: "(Internal) Basic lockable node"
	interface: internal

class P_NODE[G]

feature { P_CONTAINER, P_MUTATOR } -- Item

	item : G

	set_item(it : G) is
		do
			item := it
		ensure
			done: item = it
		end

feature { P_CONTAINER, P_MUTATOR } -- Lock status

	is_locked : BOOLEAN
		-- Locked status.

feature { P_MUTATOR }
	
	lock is
		require
			unlocked: not is_locked
		do
			is_locked := true
		ensure
			done: is_locked
		end

	unlock is
		require
			locked: is_locked
		do
			is_locked := false
		ensure
			done: not is_locked
		end

end
