-- Pylon: a foundation library; version 0.81(beta); 1997-05-08

-- 
-- Copyright (c) 1997 AlterSoft, England, E.U.
-- 
-- Permission is hereby granted, without written agreement and without
-- licence or royalty fees, to use, copy, modify, or distribute this source
-- code or binary programs using it or part of it, subject to the following
-- condition:
-- 
-- The above copyright notice and the following disclaimer must appear in
-- all copies or substantial portions of this source code. (Binary programs
-- derived from the source code can be distributed without restriction or
-- mention of the origin of the source.)
-- 
-- THIS SOFTWARE IS PROVIDED BY ALTERSOFT AND THE AUTHORS ``AS IS'' AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-- ARE DISCLAIMED. IN NO EVENT SHALL ALTERSOFT OR THE AUTHORS BE LIABLE
-- TO ANY PARTY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
-- CONSEQUENTIAL DAMAGES ARISING IN ANY WAY OUT OF THE USE OF THIS SOURCE
-- CODE.
-- 

indexing
	cluster: Pylon, Container
	descpription: "Abstract set"
	interface: abstract

deferred class P_SET[G]

inherit
	P_SEARCHABLE[G,G]
		redefine
			search
		end

feature -- Search

	search(it : G) is
			-- Search using `is_equal' for comparisons.
		deferred
		ensure then
			search_eq_has: found implies has(it)
			item_set: found implies item.is_equal(it)
		end

	found_count : INTEGER is
			-- A set has only one copy of each item.
		do
			Result := 1
		ensure then
			set_count: Result = 1
		end
	
	has(it : G) : BOOLEAN is
			-- Does the container has a - unique - copy of the object? 
		deferred
		end

feature -- Update 

	add(it : G) is
			-- Add an item to the container.
		require
			writable: is_writable
			not_void: not is_void(it)
			has_not: not has(it)
		deferred
		ensure
			keep_reference: has(it)
		end
	
	remove is
			-- Remove the current item.
		require
			writable: is_writable
			not_empty: not is_empty
		deferred
		ensure
			done: -- not has(old item)
		end

feature -- Conversion

	to_list : P_LIST[G] is
			-- Convert the set to a list.
		deferred
		ensure
			done: Result /= Void and then Result.count = count
			is_shallow_copy: -- new list, but real items
		end

end
