-- Pylon: a foundation library; version 0.81(beta); 1997-05-08

-- 
-- Copyright (c) 1997 AlterSoft, England, E.U.
-- 
-- Permission is hereby granted, without written agreement and without
-- licence or royalty fees, to use, copy, modify, or distribute this source
-- code or binary programs using it or part of it, subject to the following
-- condition:
-- 
-- The above copyright notice and the following disclaimer must appear in
-- all copies or substantial portions of this source code. (Binary programs
-- derived from the source code can be distributed without restriction or
-- mention of the origin of the source.)
-- 
-- THIS SOFTWARE IS PROVIDED BY ALTERSOFT AND THE AUTHORS ``AS IS'' AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-- ARE DISCLAIMED. IN NO EVENT SHALL ALTERSOFT OR THE AUTHORS BE LIABLE
-- TO ANY PARTY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
-- CONSEQUENTIAL DAMAGES ARISING IN ANY WAY OUT OF THE USE OF THIS SOURCE
-- CODE.
-- 

indexing
	cluster: Pylon, Misc
	description: "Text (ASCII) representation of an object (in/out)"
	interface: inheritance
	 
deferred class P_TEXT_OBJECT

feature -- Public interface
	
	to_string : STRING is
		local
			tm : P_TEXT_OBJECT_MANAGER
		do
			!!tm.make_out
			object_to_string(tm)
			Result := tm.output_string
		ensure
			is_copy: Result /= Void
		end

	from_string(str:STRING) is
			-- Init object from string.
		require
			valid: str /= Void
		local
			tm : P_TEXT_OBJECT_MANAGER
		do
			!!tm.make_in(str)
			string_to_object(tm)
		ensure
			done: -- success implies to_string.is_equal(str)
		end

feature { PUBLIC_NONE } -- Methods to effect
	
	object_to_string(tm : P_TEXT_OBJECT_MANAGER) is
			-- Convert object to string format thanks to 
			-- the 'tm' facility.
		require
			valid_manager: tm /= Void
		deferred
		end

	string_to_object(tm : P_TEXT_OBJECT_MANAGER) is
			-- Convert string to object thanks to the 'tm' 
			-- facility. The heir shall check if 'tm' can parse
			-- succesfully the input string and maintain the 
			-- invariant otherwise. 
		require
			valid_manager: tm /= Void
		deferred
		end

end
